﻿////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
//
//	danmaq Nineball-Library
//		Copyright (c) 2008-2013 danmaq all rights reserved.
//
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

namespace danmaq.nineball.data.input
{

	//* ━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━ *
	/// <summary>XBOX360 ゲームパッド ボタン一覧列挙体。</summary>
	public enum EGamePadButtons
	{

		/// <summary>割り当てられません。</summary>
		none,

		/// <summary>スタート ボタン。</summary>
		start,

		/// <summary>バック ボタン。</summary>
		back,

		/// <summary>ビッグ ボタン。</summary>
		bigButton,

		/// <summary>Aボタン。</summary>
		A,

		/// <summary>Bボタン。</summary>
		B,

		/// <summary>Xボタン。</summary>
		X,

		/// <summary>Yボタン。</summary>
		Y,

		/// <summary>左ショルダー ボタン。</summary>
		leftShoulder,

		/// <summary>右ショルダー ボタン。</summary>
		rightShoulder,

		/// <summary>左トリガー ボタン。</summary>
		leftTrigger,

		/// <summary>右トリガー ボタン。</summary>
		rightTrigger,

		/// <summary>十字 ボタン。</summary>
		dPad,

		/// <summary>左スティック ボタン。</summary>
		leftThumb,

		/// <summary>右スティック ボタン。</summary>
		rightThumb,

		/// <summary>予約(使用できません)。</summary>
		__reserved,
	}
}
